// Author: Adrian Huang
// Email: sanyuexx@hotmail.com
// Weblog: http://www.cnblogs.com/dah/
// 2007.10

package fxunit.reflect
{
	import flash.utils.describeType;
	
	import fxunit.utils.DictionaryFx;
	
	public class ClassInfo extends ReflectionInfo
	{
		private static var _dict:DictionaryFx = new DictionaryFx();
		
		private var _methods:Array = new Array();
		
		public function get methods():Array
		{
			return _methods;
		}
		
		public static function of(className:Class):ClassInfo
		{
			if (!_dict.contains(className))
			{
				var typeInfo:XML = describeType(new className());
				_dict.put(className, fromTypeInfoXML(typeInfo));
			}
			return ClassInfo(_dict.geti(className));
		}
				
		protected static function fromTypeInfoXML(xml:XML):ClassInfo
		{
			var ci:ClassInfo = new ClassInfo();
			ci._name = xml.@name;
			for each (var methodNode:XML in xml.method)
			{
				var mi:MethodInfo = new MethodInfo(methodNode.@name);
				for each (var meta:XML in methodNode.metadata)
				{
					var mdi:MetadataInfo = new MetadataInfo(meta.@name);
					for each (var arg:XML in meta.arg)
					{
						mdi.args.put(arg.@key.toString(), arg.@value.toString());
					}
					mi.metadata.push(mdi);
				}
				ci._methods.push(mi);
			}
			return ci;
		}
	}
}